﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using C1.WPF.Theming;

namespace WPF_DataGrid_TotalOnHeader
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Grid_Loaded(object sender, RoutedEventArgs e)
        {
            this.DataContext = new ViewModel();
            grid.ColumnHeaderHeight = 40;

            Application.Current.Resources.MergedDictionaries.
   Add(C1Theme.GetCurrentThemeResources(new C1.WPF.Theming.BureauBlack.C1ThemeBureauBlack()));
        }
    }

    class ViewModel : INotifyPropertyChanged
    {
        public ViewModel()
        {
            this.Employees = new ObservableCollection<Employee>();
            this.Employees.CollectionChanged += Employees_CollectionChanged;
            Employees.Add(new Employee() { Name = "Fuller", Designation = "Associate SW Engg", Salary = 20000 });
            Employees.Add(new Employee() { Name = "Victor", Designation = "SW Engg", Salary = 30000 });
            Employees.Add(new Employee() { Name = "John", Designation = "Senior SW Engg", Salary = 45000 });
            Employees.Add(new Employee() { Name = "Joe", Designation = "Associate SW Engg", Salary = 25000 });
            Employees.Add(new Employee() { Name = "Rick", Designation = "SW Engg", Salary = 35000 });
            Employees.Add(new Employee() { Name = "Samantha", Designation = "SW Engg", Salary = 32000 });
            Employees.Add(new Employee() { Name = "Rose", Designation = "SW Engg", Salary = 40000 });
            Employees.Add(new Employee() { Name = "William", Designation = "Associate SW Engg", Salary = 22000 });
            Employees.Add(new Employee() { Name = "Eric", Designation = "Senior SW Engg", Salary = 50000 });
        }

        private void Employees_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            if (e.NewItems != null)
            {
                foreach (object emp in e.NewItems)
                {
                    (emp as INotifyPropertyChanged).PropertyChanged
                        += new PropertyChangedEventHandler(EmpPropertyChanged);
                }
            }

            if (e.OldItems != null)
            {
                foreach (object emp in e.OldItems)
                {
                    (emp as INotifyPropertyChanged).PropertyChanged
                        -= new PropertyChangedEventHandler(EmpPropertyChanged);
                }
            }
        }

        private void EmpPropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            OnPropertyChanged("TotalSalary");
            OnPropertyChanged("CountOfEmployees");
        }

        public ObservableCollection<Employee> Employees
        {
            get;
            set;
        }

        public int TotalSalary
        {
            get
            {
                return this.Employees.Sum(p => p.Salary);
            }
        }

        public int CountOfEmployees
        {
            get
            {
                return this.Employees.Count;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }
    }

    public class Employee : INotifyPropertyChanged
    {
        private string _name;
        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
                OnPropertyChanged("Name");
            }
        }

        private string _desig;
        public string Designation
        {
            get
            {
                return _desig;
            }
            set
            {
                _desig = value;
            }
        }

        private int _sal;
        public int Salary
        {
            get
            {
                return _sal;
            }
            set
            {
                _sal = value;
                OnPropertyChanged("Quantity");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }

    }
}
